using namespace std;
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <string.h>
#include <limits.h>
#include <iostream>
#include "random.h"
#include <float.h>
#ifndef _GRAPH_H
#include "graph.h"
#endif
#define PI 3.141592653589793

extern "C" {
void dpotrf_(char *, int *, double *, int *, int *);
void dgetrf_(int *, int *, double *, int *, int *, int *);
void dgetri_(int *, double *, int *, int *, double *, int *, int *);

}


double Isampling(double** suffdata, int size, int* vert, double delta, double tau, int** A, int N)
{
   extern int NumberOfGenes;
   int nvar=NumberOfGenes;
   double T[size][size],tt[size][size],data[size][size];
   int i,j,k,s,ii,ss;
   int *AA[size],nu[size],kk[size],b[size];
   char UPLO[2]="L";
   int *IPIV;
   int INFO;  
   int lwork=3*size;
   double max_is, min_is, trial_run[1000], offset;
   double work[lwork], eesq;


   IPIV= new int[size];
   for(i=0; i<size;i++){
     AA[i]=new int[size];
   }

   for(i=0;i<size;i++)
   {  
      j=vert[i];
      for(k=0;k<size;k++)
      {
         s=vert[k];
	 if(suffdata!=NULL) data[i][k]=suffdata[j][s];
	 else data[i][k]=0.0;
	 if(i==k) data[i][k] = data[i][k]+tau;
      }
   }
    
    
   for(i=0;i<size;i++)
   {
      j=vert[i];
      for(k=0;k<size;k++)
      {
         s=vert[k];
         AA[i][k]=A[j][s];
	 if(i==k) AA[i][k]=1;
      }
   }
    
    
   for(i=0;i<size;i++)
   {
      nu[i]=0;
      for(j=(i+1);j<size;j++)
      {
         nu[i]+=AA[i][j];
      }
   }
 
   //  for(i=0;i<size;i++){cout<<nu[i]<<" ";}
    
   for(i=0;i<size;i++)
     {	kk[i]=0;
      for(j=0;j<i;j++)
      {
         kk[i]+=AA[j][i];
	 }
   }

   //for(i=0;i<size;i++){cout<<kk[i]<<" ";}
   
   for(i=0; i<size; i++) 
   {
      for(j=0; j<size; j++) 
      {
         T[i][j] = data[j][i];
      }
   }
        
   //DPOTRF( UPLO, N, A, LDA, INFO ) Cholesky decomposition from LAPACK!!!
   //DGETRF( M, N, A, LDA, IPIV, INFO ) LU Factorization
   //DGETRI( N, A, LDA, IPIV, WORK, LWORK, INFO ) Inverse... 
    
   dgetrf_(&size,&size,&T[0][0],&size,&IPIV[0],&INFO);
   
   

   dgetri_(&size,&T[0][0],&size,&IPIV[0],&work[0],&lwork,&INFO);
     
   

   dpotrf_(UPLO,&size,&T[0][0],&size,&INFO);
    
     
   for(i=1;i<size;i++)
   {
      for(j=0;j<i;j++)
      {
         T[i][j]=0;
      }
   }

    
   for(i=0;i<size;i++)
   {
      for(j=0;j<size;j++)
      {
         tt[i][j]=T[i][j]/T[j][j];
      }
   }
   
   

   for(i=1;i<size;i++)
   {
      for(j=0;j<i;j++)
      {
         tt[i][j]=0;
      }
   }

   
   for(i=0;i<size;i++)
   {
      b[i]=nu[i]+kk[i]+1;
   }
  
   
  
  double ee=0,lixo,aux,aux1,aux2,is; 
  double phi[size][size]; 
  eesq=0;
  double msqee;
  int enough=0, oldN=0;


  for(i=0;i<N;i++)
  {
     for(j=0;j<size;j++)
     {
        for(k=0;k<size;k++)
        {
           phi[j][k]=0;
	}
     }
  
     
     //STEP 3

     for(j=0;j<size;j++)
     { 
        phi[j][j]=sqrt(rchisq(delta+((double) nu[j]))); 
     }
    
     for(j=0;j<(size-1);j++)
     {
        for(k=(j+1);k<size;k++)
        {
           if(AA[j][k]!=0)
           { 
              phi[j][k]=rnor(0.0,1.0); 
	   }
	}
     }

     //STEP 4

     for(j=1;j<size;j++)
     {
        if(AA[0][j]==0)
        {
           for(k=0;k<j;k++)
           {
	     phi[0][j]+=phi[0][k]*tt[k][j];   //OK, starts at zero.
	   }  
           phi[0][j]= -phi[0][j];     
	                                     
	}
     }

     

     for(j=1;j<(size-1);j++)
     {
        for(k=(j+1);k<size;k++)
        {
           

           if(AA[j][k]==0)
           {
         
	     lixo=0;
              for(s=0;s<j;s++)
	      {  aux=0;
	      for(ii=s;ii<j;ii++)  
                 {
                    aux+=phi[s][ii]*tt[ii][j];
	         }
                 aux1=0;
                 //lixo=0;   //shoud be set before 1st loop?
                 for(ii=s;ii<k;ii++)
                 {
                    aux1+=phi[s][ii]*tt[ii][k];
		   
	         }
	  
	         lixo+=((phi[s][j]+aux)/phi[j][j])*(phi[s][k]+aux1);
		 

	      }
	      aux2=0;
              for(ii=j;ii<k;ii++)  
              {
                 aux2+=phi[j][ii]*tt[ii][k];
		
	      }
	      
              phi[j][k]=-aux2-lixo;
	      

	   }
        }
     }

    
     
     //STEP 5


    
     is=0;

     for(j=0;j<(size-1);j++)
     {
       for(k=(j+1);k<size;k++)          
	 { 
           if(AA[j][k]!=1)
           {
	     if(phi[j][j]< sqrt(DBL_MAX-is))
	     is+=phi[j][k]*phi[j][k];  
	     else{
	       is=DBL_MAX;
	       break;}
	   }
        }
       if(is==DBL_MAX) break;
     }            
     if(i < 1000){
       trial_run[i]=is;
       if(i==0){
	 max_is=is;
	 min_is=is;}
       else if(is > max_is) max_is=is;
       else if (is < min_is) min_is=is;	 
       if(i==999){
	 offset=min_is;
	 for(j=0 ;j <=999 ;j++)
	   if(trial_run[j]-offset < 1400.0)
	     ee+=exp((-0.5)*(trial_run[j]-offset));
       } } 
     else{  
       if(is-offset < 1400.0)
	 ee+=exp((-0.5)*(is-offset));  //will force ee to be at least exp(-.5)
     }
  }
  ee=ee/(N);

  
  double CC;
  CC=0;
  for(i=0;i<size;i++)
  {
    
    CC+=(lgamma((delta+nu[i])/2.0))+(log(T[i][i])*(delta+b[i]-1));
        
  }
   
  
  for(i=0; i<size; i++)
  {
     delete[] AA[i];
     
  }

  delete[] IPIV;
  if(ee==0){ printf("warning, 0  wt. min_is=%.10f \n", min_is);fflush(stdout);
  
 }

  ee=log(ee)-offset/2.0;

  return CC+ee;

}
   								   











