using namespace std;
 
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <string.h>
#include <limits.h>
#include <iostream>
#include <iomanip>
#include <time.h>
#include "graph.h"
#include "likecomb.h"
#include "various.h"
#include "graphfns.h"
#include "ISampling.h"



int NumberOfGenes;  //columns in dataset
int SampleSize; //rows in dataset
double **Data=NULL;
char DataFile[512];



int main(){

  int i, j, k, n_iterations, total_edges, current_edges, add;	
  int seed;	 
  double tau;
  int * edge;
  double delta;
  char GraphFile[512];
  scanf("%s", DataFile);
  scanf("%s", GraphFile);
  cin>>NumberOfGenes;
  cin>>SampleSize;
  double beta= 2.0/(NumberOfGenes-1);
  cin>>tau;
  cin>>delta;
  cin>>n_iterations;
  cin>> seed;
  double *suffdat[NumberOfGenes], current_loglike, proposed_loglike, 
    hastings_ratio, cutoff;
  time_t rawtime;
  struct tm * timeinfo;
 
  srand48(seed);
  time ( &rawtime );
  timeinfo = localtime ( &rawtime );
  printf ( "Starting date and time are: %s", asctime (timeinfo) );
 
  Data=ReadData();
  NormalizeData(Data);
  
  edge=new int[2];
  LPGraph graph = new Graph;
  total_edges=(NumberOfGenes*(NumberOfGenes-1))/2;
 
  
  for(i=0; i< NumberOfGenes; i++){
    suffdat[i]=new double[NumberOfGenes];
    for(j=0; j< NumberOfGenes; j++){
      suffdat[i][j]=getSSD(Data, i,j);
    }}
  
  graph->ReadMss(GraphFile);
  graph->InitGraphFromMss();
  graph->GetMPSubgraphs();
  graph->InitConnectedComponents();
  current_edges=0;
  for(i=0; i< NumberOfGenes; i++){
    for(j=(i+1); j< NumberOfGenes; j++){
      if(graph->Edge[i][j]==1) current_edges ++;}}
 

  
 
  current_loglike=likecomb(graph, suffdat, tau, delta);
 
 
  
  for(i=0; i< n_iterations; i++){
  
    /*the following 2 functions both select the edge to be added/deleted, 
      and make that change in the incidence matrix */
    cutoff=drand48();
    if(current_edges==0 || (cutoff <0.5 && current_edges < total_edges)){
      edge=rand_edge_add(graph, current_edges, total_edges);
      add=1;
    }
    else{
      edge=rand_edge_delete(graph, current_edges);
      add=0;
    }
    graph->GetMPSubgraphs();
    graph->InitConnectedComponents();
    proposed_loglike=likecomb(graph, suffdat, tau, delta);
    

    if(add==1){
      hastings_ratio= exp(proposed_loglike-current_loglike)*
	(total_edges-current_edges)/(current_edges+1)*beta/(1-beta);
     }
    else  hastings_ratio= exp(proposed_loglike-current_loglike)*
	    current_edges/(total_edges-current_edges+1)*(1-beta)/beta;
    if(current_edges==0 || current_edges==total_edges) 
      hastings_ratio=hastings_ratio/2;

    cutoff=drand48();

    if(cutoff< hastings_ratio){
      current_loglike=proposed_loglike;
      if(add==1) current_edges++;
      else current_edges--;
      delete[] edge;
    }
    else if(add==1){
      
      remove(graph, edge);
      delete[] edge;
    }
    else{
      Add(graph, edge);
      delete[] edge;
    }


 
     cout<<current_loglike+current_edges*log(beta)+(total_edges-current_edges)*log(1-beta)<<" ";
    for(k=0; k< NumberOfGenes;k++){	
      for(j=(k+1); j<NumberOfGenes; j++)	{
	cout<<graph->Edge[k][j]<<" ";	
	
      }}	
    cout<<endl;
    
    
  }

time ( &rawtime );
  timeinfo = localtime ( &rawtime );
  printf ( "Ending date and time are: %s", asctime (timeinfo) );

  return 1;
}



